// RichEditWAVDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RichEditWAV.h"
#include "RichEditWAVDlg.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRichEditWAVDlg dialog

CRichEditWAVDlg::CRichEditWAVDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRichEditWAVDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRichEditWAVDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRichEditWAVDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRichEditWAVDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRichEditWAVDlg, CDialog)
	//{{AFX_MSG_MAP(CRichEditWAVDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_WAVInput, OnWAVInput)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRichEditWAVDlg message handlers

BOOL CRichEditWAVDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
   m_pvvRichEdit=(CVVRichEdit*)GetDlgItem(IDC_VVRICHEDIT1);
   ASSERT(m_pvvRichEdit);
   m_pvvRichEdit->SetFocus();	

   m_Engine=m_pvvRichEdit->GetEngine();

   ::SetWindowText(m_hWnd,_T("RichEdit - WAV input"));
   
   SetDlgItemText(IDC_FileName,_T("d:\\temp\\paudicus.wav"));
   

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRichEditWAVDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRichEditWAVDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRichEditWAVDlg::OnWAVInput() 
{
     
   TCHAR  lpszFileName[128];   
   GetDlgItemText(IDC_FileName,lpszFileName,sizeof(lpszFileName));  
   
   m_Engine.SetAudioSource(lpszFileName);
   m_Engine.SetAudioState(1);  //vvasStarted
       
}

void CRichEditWAVDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}


