
#include <windows.h>
#include "smapidyn.h"

/* global data */

FT_SmAddCallback pSmAddCallback; 
FT_SmRemoveCallback pSmRemoveCallback; 
FT_SmAddPronunciation pSmAddPronunciation; 
FT_SmAddToVocab pSmAddToVocab; 
FT_SmApiVersionCheck pSmApiVersionCheck; 
FT_SmCancelPlayback pSmCancelPlayback; 
FT_SmClose pSmClose; 
FT_SmConnect pSmConnect; 
FT_SmCorrectText pSmCorrectText; 
FT_SmCorrectTextCancel pSmCorrectTextCancel; 
FT_SmDefineGrammar pSmDefineGrammar; 
FT_SmDefineVocab pSmDefineVocab; 
FT_SmDisableVocab pSmDisableVocab; 
FT_SmDiscardData pSmDiscardData; 
FT_SmDisconnect pSmDisconnect; 
FT_SmDispatch pSmDispatch; 
FT_SmDetachSessions pSmDetachSessions; 
FT_SmEnableVocab pSmEnableVocab; 
FT_SmEventNotify pSmEventNotify; 
FT_SmHaltRecognizer pSmHaltRecognizer; 
FT_SmMicOff pSmMicOff; 
FT_SmMicOn pSmMicOn; 
FT_SmNewContext pSmNewContext; 
FT_SmOpen pSmOpen; 
FT_SmPlayMessage pSmPlayMessage; 
FT_SmPlayUtterance pSmPlayUtterance; 
FT_SmPlayWords pSmPlayWords; 
FT_SmQuery pSmQuery; 
FT_SmQueryAddedWords pSmQueryAddedWords; 
FT_SmQueryAlternates pSmQueryAlternates; 
FT_SmQueryDefault pSmQueryDefault; 
FT_SmQueryEnabledVocabs pSmQueryEnabledVocabs; 
FT_SmQueryEnrollIds pSmQueryEnrollIds; 
FT_SmQueryLanguages pSmQueryLanguages; 
FT_SmQueryPronunciation pSmQueryPronunciation; 
FT_SmQueryPronunciations pSmQueryPronunciations; 
FT_SmQuerySessions pSmQuerySessions; 
FT_SmQuerySpeechData pSmQuerySpeechData; 
FT_SmQueryTasks pSmQueryTasks; 
FT_SmQueryUserInfo pSmQueryUserInfo; 
FT_SmQueryUsers pSmQueryUsers; 
FT_SmQueryVocabs pSmQueryVocabs; 
FT_SmQueryWord pSmQueryWord; 
FT_SmReceiveMsg pSmReceiveMsg; 
FT_SmRecognizeNextWord pSmRecognizeNextWord; 
FT_SmReleaseFocus pSmReleaseFocus; 
FT_SmRemoveFromVocab pSmRemoveFromVocab; 
FT_SmRemovePronunciation pSmRemovePronunciation; 
FT_SmRequestFocus pSmRequestFocus; 
FT_SmRequestMicOff pSmRequestMicOff; 
FT_SmRequestMicOn pSmRequestMicOn; 
FT_SmRestoreSpeechData pSmRestoreSpeechData; 
FT_SmSaveSpeechData pSmSaveSpeechData; 
FT_SmSet pSmSet; 
FT_SmSetDefault pSmSetDefault; 
FT_SmSetUserInfo pSmSetUserInfo; 
FT_SmUndefineVocab pSmUndefineVocab; 
FT_SmWordCorrection pSmWordCorrection; 
FT_SmGetAlphabets pSmGetAlphabets; 
FT_SmGetApplication pSmGetApplication; 
FT_SmGetApplications pSmGetApplications; 
FT_SmGetAlternates pSmGetAlternates; 
FT_SmGetAudioLevel pSmGetAudioLevel; 
FT_SmGetDescriptions pSmGetDescriptions; 
FT_SmGetEngineState pSmGetEngineState; 
FT_SmGetEnrollId pSmGetEnrollId; 
FT_SmGetEnrollIds pSmGetEnrollIds; 
FT_SmGetEventId pSmGetEventId; 
FT_SmGetEventOptions pSmGetEventOptions; 
FT_SmGetFirmWords pSmGetFirmWords; 
FT_SmGetFocusState pSmGetFocusState; 
FT_SmGetFocusChangeReason pSmGetFocusChangeReason; 
FT_SmGetGrammarPath pSmGetGrammarPath; 
FT_SmGetVocabPath pSmGetVocabPath; 
FT_SmGetInfirmWords pSmGetInfirmWords; 
FT_SmGetItemValue pSmGetItemValue; 
FT_SmGetLanguages pSmGetLanguages; 
FT_SmGetMicState pSmGetMicState; 
FT_SmGetMsgName pSmGetMsgName; 
FT_SmGetMsgType pSmGetMsgType; 
FT_SmGetNameValue pSmGetNameValue; 
FT_SmGetNumberWordMsgs pSmGetNumberWordMsgs; 
FT_SmGetPercentages pSmGetPercentages; 
FT_SmGetPhraseState pSmGetPhraseState; 
FT_SmGetPronunciations pSmGetPronunciations; 
FT_SmGetRc pSmGetRc; 
FT_SmGetRcName pSmGetRcName; 
FT_SmGetRcDescription pSmGetRcDescription; 
FT_SmReturnRc pSmReturnRc; 
FT_SmReturnRcName pSmReturnRcName; 
FT_SmReturnRcDescription pSmReturnRcDescription; 
FT_SmGetScripts pSmGetScripts; 
FT_SmGetService pSmGetService; 
FT_SmGetSessionId pSmGetSessionId; 
FT_SmGetSeverity pSmGetSeverity; 
FT_SmGetSpeechDataArchive pSmGetSpeechDataArchive; 
FT_SmGetSpeechDataOptions pSmGetSpeechDataOptions; 
FT_SmGetSpeechDataSize pSmGetSpeechDataSize; 
FT_SmGetSpeechDataVersion pSmGetSpeechDataVersion; 
FT_SmGetSpelling pSmGetSpelling; 
FT_SmGetSpellings pSmGetSpellings; 
FT_SmGetStates pSmGetStates; 
FT_SmGetStatus pSmGetStatus; 
FT_SmGetTags pSmGetTags; 
FT_SmGetTask pSmGetTask; 
FT_SmGetTasks pSmGetTasks; 
FT_SmGetTimes pSmGetTimes; 
FT_SmGetUserId pSmGetUserId; 
FT_SmGetUserIds pSmGetUserIds; 
FT_SmGetUsers pSmGetUsers; 
FT_SmGetUtteranceNumber pSmGetUtteranceNumber; 
FT_SmGetVocabList pSmGetVocabList; 
FT_SmGetVocabName pSmGetVocabName; 
FT_SmGetVocWords pSmGetVocWords; 
FT_SmGetWords pSmGetWords; 
FT_SmGetAnnotations pSmGetAnnotations; 
FT_SmGetWordTimes pSmGetWordTimes; 

/* local data */

static HMODULE   hdll = NULL;

/* code */

int SmApiLoadLibrary(void)
{
   HKEY     hkey;
   char     pathname[_MAX_PATH];
   DWORD    pathnamelen = _MAX_PATH;
   LONG     rc;

   // get path to SMAPI.DLL from registry entry 

   rc = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
                     "SOFTWARE\\IBM\\VoiceType\\Engine\\Directories",
                     0,
                     KEY_READ,
                     &hkey);
   if (rc != ERROR_SUCCESS)
      return (SM_RC_SERVER_ERROR); 

   rc = RegQueryValueEx(hkey,"Bin",0,NULL,pathname,&pathnamelen);
   if (rc != ERROR_SUCCESS)
      return (SM_RC_SERVER_ERROR); 

   RegCloseKey(hkey);

   // dynamically load SMAPI.DLL

   strcat(pathname,"\\smapi.dll");
   hdll = LoadLibrary(pathname);

   if (hdll == NULL)
      return (SM_RC_SERVER_ERROR);
    
   pSmAddCallback = (FT_SmAddCallback)GetProcAddress(hdll,"SmAddCallback"); 
   pSmRemoveCallback = (FT_SmRemoveCallback)GetProcAddress(hdll,"SmRemoveCallback"); 
   pSmAddPronunciation = (FT_SmAddPronunciation)GetProcAddress(hdll,"SmAddPronunciation"); 
   pSmAddToVocab = (FT_SmAddToVocab)GetProcAddress(hdll,"SmAddToVocab"); 
   pSmApiVersionCheck = (FT_SmApiVersionCheck)GetProcAddress(hdll,"SmApiVersionCheck"); 
   pSmCancelPlayback = (FT_SmCancelPlayback)GetProcAddress(hdll,"SmCancelPlayback"); 
   pSmClose = (FT_SmClose)GetProcAddress(hdll,"SmClose"); 
   pSmConnect = (FT_SmConnect)GetProcAddress(hdll,"SmConnect"); 
   pSmCorrectText = (FT_SmCorrectText)GetProcAddress(hdll,"SmCorrectText"); 
   pSmCorrectTextCancel = (FT_SmCorrectTextCancel)GetProcAddress(hdll,"SmCorrectTextCancel"); 
   pSmDefineGrammar = (FT_SmDefineGrammar)GetProcAddress(hdll,"SmDefineGrammar"); 
   pSmDefineVocab = (FT_SmDefineVocab)GetProcAddress(hdll,"SmDefineVocab"); 
   pSmDisableVocab = (FT_SmDisableVocab)GetProcAddress(hdll,"SmDisableVocab"); 
   pSmDiscardData = (FT_SmDiscardData)GetProcAddress(hdll,"SmDiscardData"); 
   pSmDisconnect = (FT_SmDisconnect)GetProcAddress(hdll,"SmDisconnect"); 
   pSmDispatch = (FT_SmDispatch)GetProcAddress(hdll,"SmDispatch"); 
   pSmDetachSessions = (FT_SmDetachSessions)GetProcAddress(hdll,"SmDetachSessions"); 
   pSmEnableVocab = (FT_SmEnableVocab)GetProcAddress(hdll,"SmEnableVocab"); 
   pSmEventNotify = (FT_SmEventNotify)GetProcAddress(hdll,"SmEventNotify"); 
   pSmHaltRecognizer = (FT_SmHaltRecognizer)GetProcAddress(hdll,"SmHaltRecognizer"); 
   pSmMicOff = (FT_SmMicOff)GetProcAddress(hdll,"SmMicOff"); 
   pSmMicOn = (FT_SmMicOn)GetProcAddress(hdll,"SmMicOn"); 
   pSmNewContext = (FT_SmNewContext)GetProcAddress(hdll,"SmNewContext"); 
   pSmOpen = (FT_SmOpen)GetProcAddress(hdll,"SmOpen"); 
   pSmPlayMessage = (FT_SmPlayMessage)GetProcAddress(hdll,"SmPlayMessage"); 
   pSmPlayUtterance = (FT_SmPlayUtterance)GetProcAddress(hdll,"SmPlayUtterance"); 
   pSmPlayWords = (FT_SmPlayWords)GetProcAddress(hdll,"SmPlayWords"); 
   pSmQuery = (FT_SmQuery)GetProcAddress(hdll,"SmQuery"); 
   pSmQueryAddedWords = (FT_SmQueryAddedWords)GetProcAddress(hdll,"SmQueryAddedWords"); 
   pSmQueryAlternates = (FT_SmQueryAlternates)GetProcAddress(hdll,"SmQueryAlternates"); 
   pSmQueryDefault = (FT_SmQueryDefault)GetProcAddress(hdll,"SmQueryDefault"); 
   pSmQueryEnabledVocabs = (FT_SmQueryEnabledVocabs)GetProcAddress(hdll,"SmQueryEnabledVocabs"); 
   pSmQueryEnrollIds = (FT_SmQueryEnrollIds)GetProcAddress(hdll,"SmQueryEnrollIds"); 
   pSmQueryLanguages = (FT_SmQueryLanguages)GetProcAddress(hdll,"SmQueryLanguages"); 
   pSmQueryPronunciation = (FT_SmQueryPronunciation)GetProcAddress(hdll,"SmQueryPronunciation"); 
   pSmQueryPronunciations = (FT_SmQueryPronunciations)GetProcAddress(hdll,"SmQueryPronunciations"); 
   pSmQuerySessions = (FT_SmQuerySessions)GetProcAddress(hdll,"SmQuerySessions"); 
   pSmQuerySpeechData = (FT_SmQuerySpeechData)GetProcAddress(hdll,"SmQuerySpeechData"); 
   pSmQueryTasks = (FT_SmQueryTasks)GetProcAddress(hdll,"SmQueryTasks"); 
   pSmQueryUserInfo = (FT_SmQueryUserInfo)GetProcAddress(hdll,"SmQueryUserInfo"); 
   pSmQueryUsers = (FT_SmQueryUsers)GetProcAddress(hdll,"SmQueryUsers"); 
   pSmQueryVocabs = (FT_SmQueryVocabs)GetProcAddress(hdll,"SmQueryVocabs"); 
   pSmQueryWord = (FT_SmQueryWord)GetProcAddress(hdll,"SmQueryWord"); 
   pSmReceiveMsg = (FT_SmReceiveMsg)GetProcAddress(hdll,"SmReceiveMsg"); 
   pSmRecognizeNextWord = (FT_SmRecognizeNextWord)GetProcAddress(hdll,"SmRecognizeNextWord"); 
   pSmReleaseFocus = (FT_SmReleaseFocus)GetProcAddress(hdll,"SmReleaseFocus"); 
   pSmRemoveFromVocab = (FT_SmRemoveFromVocab)GetProcAddress(hdll,"SmRemoveFromVocab"); 
   pSmRemovePronunciation = (FT_SmRemovePronunciation)GetProcAddress(hdll,"SmRemovePronunciation"); 
   pSmRequestFocus = (FT_SmRequestFocus)GetProcAddress(hdll,"SmRequestFocus"); 
   pSmRequestMicOff = (FT_SmRequestMicOff)GetProcAddress(hdll,"SmRequestMicOff"); 
   pSmRequestMicOn = (FT_SmRequestMicOn)GetProcAddress(hdll,"SmRequestMicOn"); 
   pSmRestoreSpeechData = (FT_SmRestoreSpeechData)GetProcAddress(hdll,"SmRestoreSpeechData"); 
   pSmSaveSpeechData = (FT_SmSaveSpeechData)GetProcAddress(hdll,"SmSaveSpeechData"); 
   pSmSet = (FT_SmSet)GetProcAddress(hdll,"SmSet"); 
   pSmSetDefault = (FT_SmSetDefault)GetProcAddress(hdll,"SmSetDefault"); 
   pSmSetUserInfo = (FT_SmSetUserInfo)GetProcAddress(hdll,"SmSetUserInfo"); 
   pSmUndefineVocab = (FT_SmUndefineVocab)GetProcAddress(hdll,"SmUndefineVocab"); 
   pSmWordCorrection = (FT_SmWordCorrection)GetProcAddress(hdll,"SmWordCorrection"); 
   pSmGetAlphabets = (FT_SmGetAlphabets)GetProcAddress(hdll,"SmGetAlphabets"); 
   pSmGetApplication = (FT_SmGetApplication)GetProcAddress(hdll,"SmGetApplication"); 
   pSmGetApplications = (FT_SmGetApplications)GetProcAddress(hdll,"SmGetApplications"); 
   pSmGetAlternates = (FT_SmGetAlternates)GetProcAddress(hdll,"SmGetAlternates"); 
   pSmGetAudioLevel = (FT_SmGetAudioLevel)GetProcAddress(hdll,"SmGetAudioLevel"); 
   pSmGetDescriptions = (FT_SmGetDescriptions)GetProcAddress(hdll,"SmGetDescriptions"); 
   pSmGetEngineState = (FT_SmGetEngineState)GetProcAddress(hdll,"SmGetEngineState"); 
   pSmGetEnrollId = (FT_SmGetEnrollId)GetProcAddress(hdll,"SmGetEnrollId"); 
   pSmGetEnrollIds = (FT_SmGetEnrollIds)GetProcAddress(hdll,"SmGetEnrollIds"); 
   pSmGetEventId = (FT_SmGetEventId)GetProcAddress(hdll,"SmGetEventId"); 
   pSmGetEventOptions = (FT_SmGetEventOptions)GetProcAddress(hdll,"SmGetEventOptions"); 
   pSmGetFirmWords = (FT_SmGetFirmWords)GetProcAddress(hdll,"SmGetFirmWords"); 
   pSmGetFocusState = (FT_SmGetFocusState)GetProcAddress(hdll,"SmGetFocusState"); 
   pSmGetFocusChangeReason = (FT_SmGetFocusChangeReason)GetProcAddress(hdll,"SmGetFocusChangeReason"); 
   pSmGetGrammarPath = (FT_SmGetGrammarPath)GetProcAddress(hdll,"SmGetGrammarPath"); 
   pSmGetVocabPath = (FT_SmGetVocabPath)GetProcAddress(hdll,"SmGetVocabPath"); 
   pSmGetInfirmWords = (FT_SmGetInfirmWords)GetProcAddress(hdll,"SmGetInfirmWords"); 
   pSmGetItemValue = (FT_SmGetItemValue)GetProcAddress(hdll,"SmGetItemValue"); 
   pSmGetLanguages = (FT_SmGetLanguages)GetProcAddress(hdll,"SmGetLanguages"); 
   pSmGetMicState = (FT_SmGetMicState)GetProcAddress(hdll,"SmGetMicState"); 
   pSmGetMsgName = (FT_SmGetMsgName)GetProcAddress(hdll,"SmGetMsgName"); 
   pSmGetMsgType = (FT_SmGetMsgType)GetProcAddress(hdll,"SmGetMsgType"); 
   pSmGetNameValue = (FT_SmGetNameValue)GetProcAddress(hdll,"SmGetNameValue"); 
   pSmGetNumberWordMsgs = (FT_SmGetNumberWordMsgs)GetProcAddress(hdll,"SmGetNumberWordMsgs"); 
   pSmGetPercentages = (FT_SmGetPercentages)GetProcAddress(hdll,"SmGetPercentages"); 
   pSmGetPhraseState = (FT_SmGetPhraseState)GetProcAddress(hdll,"SmGetPhraseState"); 
   pSmGetPronunciations = (FT_SmGetPronunciations)GetProcAddress(hdll,"SmGetPronunciations"); 
   pSmGetRc = (FT_SmGetRc)GetProcAddress(hdll,"SmGetRc"); 
   pSmGetRcName = (FT_SmGetRcName)GetProcAddress(hdll,"SmGetRcName"); 
   pSmGetRcDescription = (FT_SmGetRcDescription)GetProcAddress(hdll,"SmGetRcDescription"); 
   pSmReturnRc = (FT_SmReturnRc)GetProcAddress(hdll,"SmReturnRc"); 
   pSmReturnRcName = (FT_SmReturnRcName)GetProcAddress(hdll,"SmReturnRcName"); 
   pSmReturnRcDescription = (FT_SmReturnRcDescription)GetProcAddress(hdll,"SmReturnRcDescription"); 
   pSmGetScripts = (FT_SmGetScripts)GetProcAddress(hdll,"SmGetScripts"); 
   pSmGetService = (FT_SmGetService)GetProcAddress(hdll,"SmGetService"); 
   pSmGetSessionId = (FT_SmGetSessionId)GetProcAddress(hdll,"SmGetSessionId"); 
   pSmGetSeverity = (FT_SmGetSeverity)GetProcAddress(hdll,"SmGetSeverity"); 
   pSmGetSpeechDataArchive = (FT_SmGetSpeechDataArchive)GetProcAddress(hdll,"SmGetSpeechDataArchive"); 
   pSmGetSpeechDataOptions = (FT_SmGetSpeechDataOptions)GetProcAddress(hdll,"SmGetSpeechDataOptions"); 
   pSmGetSpeechDataSize = (FT_SmGetSpeechDataSize)GetProcAddress(hdll,"SmGetSpeechDataSize"); 
   pSmGetSpeechDataVersion = (FT_SmGetSpeechDataVersion)GetProcAddress(hdll,"SmGetSpeechDataVersion"); 
   pSmGetSpelling = (FT_SmGetSpelling)GetProcAddress(hdll,"SmGetSpelling"); 
   pSmGetSpellings = (FT_SmGetSpellings)GetProcAddress(hdll,"SmGetSpellings"); 
   pSmGetStates = (FT_SmGetStates)GetProcAddress(hdll,"SmGetStates"); 
   pSmGetStatus = (FT_SmGetStatus)GetProcAddress(hdll,"SmGetStatus"); 
   pSmGetTags = (FT_SmGetTags)GetProcAddress(hdll,"SmGetTags"); 
   pSmGetTask = (FT_SmGetTask)GetProcAddress(hdll,"SmGetTask"); 
   pSmGetTasks = (FT_SmGetTasks)GetProcAddress(hdll,"SmGetTasks"); 
   pSmGetTimes = (FT_SmGetTimes)GetProcAddress(hdll,"SmGetTimes"); 
   pSmGetUserId = (FT_SmGetUserId)GetProcAddress(hdll,"SmGetUserId"); 
   pSmGetUserIds = (FT_SmGetUserIds)GetProcAddress(hdll,"SmGetUserIds"); 
   pSmGetUsers = (FT_SmGetUsers)GetProcAddress(hdll,"SmGetUsers"); 
   pSmGetUtteranceNumber = (FT_SmGetUtteranceNumber)GetProcAddress(hdll,"SmGetUtteranceNumber"); 
   pSmGetVocabList = (FT_SmGetVocabList)GetProcAddress(hdll,"SmGetVocabList"); 
   pSmGetVocabName = (FT_SmGetVocabName)GetProcAddress(hdll,"SmGetVocabName"); 
   pSmGetVocWords = (FT_SmGetVocWords)GetProcAddress(hdll,"SmGetVocWords"); 
   pSmGetWords = (FT_SmGetWords)GetProcAddress(hdll,"SmGetWords"); 
   pSmGetAnnotations = (FT_SmGetAnnotations)GetProcAddress(hdll,"SmGetAnnotations"); 
   pSmGetWordTimes = (FT_SmGetWordTimes)GetProcAddress(hdll,"SmGetWordTimes"); 
                                                             
   return (SM_RC_OK);
}

int SmApiFreeLibrary(void)
{
   if (hdll != NULL)
      FreeLibrary(hdll);

   return (SM_RC_OK);
}
