// MacroLst.cpp : implementation file
//

#include "stdafx.h"
#include "smdplus.h"
#include "Macrolst.h"
#include "vtdm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMacroList dialog


CMacroList::CMacroList(CWnd* pParent,
                       VTDictationMacroDatabase* macrodatabase )
	: CDialog(CMacroList::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMacroList)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
        m_macrodatabase = macrodatabase;
}


void CMacroList::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMacroList)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMacroList, CDialog)
	//{{AFX_MSG_MAP(CMacroList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMacroList message handlers

BOOL CMacroList::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
        
 	InsertMacros();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void CMacroList::InsertMacros(void)
{
   VTDictationMacro* macro;
   CListCtrl*        listctrl;
   int               name_width = 1;
   int               description_width = 1;
   int               width;

   listctrl = GetMacroListCtrl();

   listctrl->InsertColumn(0,"Name");
   listctrl->InsertColumn(1,"Description");

   m_macrodatabase->setfirst();

   while ( (macro = m_macrodatabase->getnext()) != NULL)
   {
      int i = listctrl->InsertItem(0,macro->name());
      listctrl->SetItemText(i,1,macro->description());

      width = listctrl->GetStringWidth(macro->name());
      if (width > name_width)
         name_width = width;

      width = listctrl->GetStringWidth(macro->description());
      if (width > description_width)
         description_width = width;
   }

   listctrl->SetColumnWidth(0,name_width);
   listctrl->SetColumnWidth(1,description_width);

   return;
}
