//------------------------------------------------------------------------------
//
//    COPYRIGHT:
//    ----------
//    Copyright (C) International Business Machines Corp., 1996.
//
//      DISCLAIMER OF WARRANTIES:
//      -------------------------
//      The following [enclosed] code is sample code created by IBM
//      Corporation.  This sample code is not part of any standard IBM
//      product and is provided to you solely for the purpose of
//      assisting you in the development of your applications.  The
//      code is provided "AS IS", without warranty of any kind.  IBM
//      shall not be liable for any damages arising out of your use of
//      the sample code, even if they have been advised of the
//      possibility of such damages.
//
//------------------------------------------------------------------------------
//
//  defgram.h : header file for the DefineGrammar dialog class
//
//------------------------------------------------------------------------------

#include "vtproxy.h"

class DefineGrammar : public CDialog
{

public:
	DefineGrammar(VTProxy   &aVTProxy,
                 CWnd      *pParent = NULL); // standard constructor
   
   const char *vocabularyName();

   // Dialog Data
	//{{AFX_DATA(DefineGrammar)
	enum { IDD = IDD_DEFINE_GRAMMER };
	CEdit	m_szVocabularyWords;
	CEdit	m_szVocabularyName;
	//}}AFX_DATA


   // Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(DefineGrammar)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(DefineGrammar)
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

   // attributes
   VTProxy    &m_pxySMAPI;
   CString    m_vocabularyName;

};
