/******************************************************************************/
/*                                                                            */
/* COPYRIGHT:                                                                 */
/* ----------                                                                 */
/* Copyright (C) International Business Machines Corp., 1996.                 */
/*                                                                            */
/* DISCLAIMER OF WARRANTIES:                                                  */
/* -------------------------                                                  */
/* The following [enclosed] code is sample code created by IBM                */
/* Corporation.  This sample code is not part of any standard IBM product     */
/* and is provided to you solely for the purpose of assisting you in the      */
/* development of your applications.  The code is provided "AS IS",           */
/* without warranty of any kind.  IBM shall not be liable for any damages     */
/* arising out of your use of the sample code, even if they have been         */
/* advised of the possibility of such damages.                                */
/*                                                                            */
/******************************************************************************/
// smdict.h : Dictation Sample Include file
//

// Defines the program icon
#define IDI_SMDICT    99

// Defines the menu items values for the File Menu
#define IDM_EXIT       5

// Defines the menu item values for the Help Menu
#define IDM_HELP      40
#define IDM_ABOUT     41

// Defines the Button Values for the Main Window
#define IDB_CONNECT      101            // Connect
#define IDB_DISCONNECT   102            // Disconnect
#define IDB_FOCUS        103            // Focus
#define IDB_PLAYBACK     104            // Playback
#define IDB_CLEAR        105            // Clear Tags
#define IDB_BEGIN        106            // Begin Dictation
#define IDB_STOP         107            // End Dictation

// Window Identifier for the Dictation Window
#define IDX_TEXT     111

// Window Identifier for the Message Window
#define IDX_LIST     112

// Message id is one of the arguments to the SmOpen
// and is the way the Speech Engine communicates to
// our application
#define SM_MESSAGE_ID 724

// Defines the number, width, and height of Buttons
// on the main window
#define NUM_BUTTONS 7
#define BUT_WIDTH   95
#define BUT_HEIGHT  25

// Defines the string length of the character strings
// for the user id, enrollment id, and task id. All arguments
// to SmConnect
#define STR_SIZE 40
