// TestTextBoxDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestTextBox.h"
#include "TestTextBoxDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestTextBoxDlg dialog

CTestTextBoxDlg::CTestTextBoxDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestTextBoxDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestTextBoxDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestTextBoxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestTextBoxDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestTextBoxDlg, CDialog)
	//{{AFX_MSG_MAP(CTestTextBoxDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PlayBack, OnPlayBack)
	ON_BN_CLICKED(IDC_PlayBackEx2, OnPlayBackEx2)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestTextBoxDlg message handlers

BOOL CTestTextBoxDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
   m_pvvTextBox=(CVVTextBox*)GetDlgItem(IDC_VVTEXTBOX1);
   ASSERT(m_pvvTextBox);
   ::SetWindowText(m_hWnd,_T("TextBox - WAV output and Playback"));
 

   CEdit* pEdtBox=(CEdit*)GetDlgItem(IDC_FileName);
   pEdtBox->SetWindowText(_T("d:\\temp\\output.wav"));

   CButton* pCheckBox=(CButton*)GetDlgItem(IDC_CHECK1);   
	pCheckBox->SetCheck(1);
   m_pvvTextBox->SetDictationOn(TRUE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestTextBoxDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestTextBoxDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CTestTextBoxDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CTestTextBoxDlg)
	ON_EVENT(CTestTextBoxDlg, IDC_VVTEXTBOX1, 18 /* SpeechRecognized */, OnSpeechRecognizedVvtextbox1, VTS_BSTR)
	ON_EVENT(CTestTextBoxDlg, IDC_VVTEXTBOX1, 10 /* DictationStateChange */, OnDictationStateChangeVvtextbox1, VTS_BOOL)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CTestTextBoxDlg::OnSpeechRecognizedVvtextbox1(LPCTSTR strText) 
{
	// TODO: Add your control notification handler code here
	
}

void CTestTextBoxDlg::OnDictationStateChangeVvtextbox1(BOOL DictationOn) 
{
	// TODO: Add your control notification handler code here
	
}

void CTestTextBoxDlg::OnPlayBack() 
{
	 m_pvvTextBox->Playback();
	
}

void CTestTextBoxDlg::OnPlayBackEx2() 
{

   TCHAR  lpszFileName[128];
   CEdit* pEdtBox=(CEdit*)GetDlgItem(IDC_FileName);

   pEdtBox->GetWindowText(lpszFileName,sizeof(lpszFileName));

   m_pvvTextBox->PlayBackEx2(0,0, lpszFileName);
	
}



void CTestTextBoxDlg::OnCheck1() 
{

   CButton* pCheckBox=(CButton*)GetDlgItem(IDC_CHECK1);
   
	int chk=pCheckBox->GetCheck();

   if (chk==1)
      m_pvvTextBox->SetDictationOn(TRUE);
   else
      m_pvvTextBox->SetDictationOn(FALSE);


}
